#include<unistd.h>
#include<errno.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include<dirent.h>

#define C 1
#define K 2

/*****************************************************************************/

void error(void)
{
  write(STDERR_FILENO,strerror(errno),strlen(strerror(errno)));
  write(STDERR_FILENO,"\n",1);
  exit(errno);
}

/*****************************************************************************/

void usage(void)
{
  write(STDOUT_FILENO ,"usage: chfunzip [OPTIONS] file ...\n"
	"-c \t write on stdout\n"
	"-k \t keep original files\n",81);
  exit(EXIT_SUCCESS);
}

/****************************************************************************/

void suffix(char *s)
{
  write(STDERR_FILENO,"chfunzip: ",10);
  write(STDERR_FILENO,s,strlen(s));
  write(STDERR_FILENO," : unknown suffix -- ignored\n",30);
}

/*****************************************************************************/

int main(int argc, char **argv)
{
  int fh,  rh, flags=0;
  unsigned long counter=0;
  char buf[NAME_MAX+1];
  
  if(argc>1) while(*++argv)
    {
      if(**argv=='-') while(*++*argv)	 
	switch(**argv)
	  {
	  case 'c': flags|=C; break;
	  case 'k': flags|=K; break;
	  default: usage();
	  }
  
      else /* arg is a file */
	{
	  if(strlen(*argv)<4) { suffix(*argv); break; }
	  if(strcmp(*argv+strlen(*argv)-3,".cz")) { suffix(*argv); break; }
	 
	  
	  /* Write hashvalue form file in counter */
	  if((fh = open(*argv,O_RDONLY))==-1) error();
	  if(read(fh,buf,NAME_MAX)==-1) error();
	  counter = (unsigned long) atol(buf);
	  close(fh);
	 
	  if(flags&C) fh = STDOUT_FILENO;
	  else
	    {
	      strncpy(buf,*argv,strlen(*argv)-3); /* strlen(buf)-3 < NAME_MAX */
	      buf[strlen(*argv)-3]='\0';
	      if((fh = open(buf,O_WRONLY|O_CREAT,0644))==-1) error();
	    }
	  
	  if((rh = open("/dev/urandom",O_RDONLY))==-1)
	    if((rh = open("/dev/random",O_RDONLY))==-1) error();
	  
	  while(counter)
	    {
	      if(read(rh,buf,1)==-1) error();
	      if(write(fh,buf,1)==-1) error();
	      --counter;
	    }
	  close(rh);
	  close(fh);

	  if(!(flags&K)) if(unlink(*argv)==-1) error();

	} // else
    } // if
  
  exit(EXIT_SUCCESS);
}
