#include<unistd.h>
#include<errno.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include "chf.c"

#define BUFLEN 32
#define C 1
#define K 2
#define V 4

/*****************************************************************************/

void error(void)
{
  write(2,strerror(errno),strlen(strerror(errno)));
  write(2,"\n",1);
  exit(errno);
}

/*****************************************************************************/

void usage(void)
{
  write(1,"usage: chfzip [OPTIONS] file ...\n"
	"-c \t write on stdout\n"
	"-k \t keep original files\n",79);
  exit(EXIT_SUCCESS);
}

/*****************************************************************************/

int main(int argc, char **argv)
{
  int fh, i, flags=0;
  unsigned long counter=0;
  char buf[BUFLEN+1], *newfile;

  if(argc>1) while(*++argv)
    {
      if(**argv=='-') while(*++*argv)	 
	switch(**argv)
	  {
	  case 'c': flags|=C; break;
	  case 'k': flags|=K; break;
	  default: usage();
	  }
      else
	{

	  /* Ermittle Dateigre in Bytes */
	  if((fh = open(*argv,O_RDWR))==-1) error();
	  while((i=read(fh,buf,BUFLEN)))
	    switch(i)
	      {
	      case -1: error(); break;
	      default: counter+=i; break;
	      } 
	  if(close(fh)) error();
	  

	  if(flags&C) chf(1,counter);
	  else
	    {	    
	      /*
	       * File mit neuem Namen anlegen, den Hashwert hineinschreiben
	       *  und es wieder schliessen
	       */
	      newfile  = malloc(strlen(*argv)+4);
	      strcpy(newfile,*argv);
	      strcat(newfile,".cz");
	      if((fh = open(newfile,O_CREAT|O_WRONLY,0644))==-1) error();
	      free(newfile);
	      chf(fh,counter); /* Hashfunktion */
	      if(close(fh)) error();
	    } // else
	  if(!(flags&K)) if(unlink(*argv)==-1) error();
	} // else
    } // while
  exit(EXIT_SUCCESS);
}
	      
	   
